/*
File: ComThread.java
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/

package webwisdom.tango.threads;

import java.lang.*;
import java.util.*;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.MessageQueue;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.structures.ComSessionTable;

public class ComThread extends Thread {

  private Vector out;
  private Vector UIDVector;
  private MessageQueue q;
  private ComSessionTable table;
  
  public ComThread() {
    
    super();
    out = new Vector();
    UIDVector = new Vector();
    q = new MessageQueue();
    table = new ComSessionTable();
    
  }


  public void run() {

    Message m;
    int i;
    int AID;

    System.out.println("ComThread: Commutation thread started");

    while(1 == 1) {
       
      //System.out.println("ComThread: ComThread getting message from queue");
  	m = q.getMessage();
	table.putMessage(m);
	//System.out.println("ComThread: Message sent");	

    }
	

  }

  public synchronized void addThread(ThreadOut tout, int UIDpar) {
	
    Integer tmp = new Integer(UIDpar);
    
    if (UIDVector.contains(tmp)) {
      System.out.println("ComThread: user " + UIDpar + " already registered");
      return;
    }
      
    UIDVector.addElement(tmp);
    out.addElement(tout);
    System.out.println("ComThread: TOut registered in ComThread, current number of threads " + out.size());

  }

  public void removeThread(ThreadOut tout) {

    int index;
    
    index = out.indexOf(tout);
	
    if (index != -1) {
      out.removeElementAt(index);
      UIDVector.removeElementAt(index);

      System.out.println("ComThread: TOut removed from ComThread, current number of threads " + out.size());

    }
    else {

       System.out.println("ComThread: thread tout does not exist, cannot remove" );
    }


  }
  

  public ThreadOut getThread(int UIDpar) {

    ThreadOut result;
    int index;
    Integer tmp = new Integer(UIDpar);

    index = UIDVector.indexOf(tmp);

    if (index != -1) {
      result = (ThreadOut) out.elementAt(index);
    }
    else {
      System.out.println("ComThread: user " + UIDpar + " not registered ");
      result = null;
    }

   
    return result;
  }
    
	
	public void sendTo(int UID, Message m) {
  
  		ThreadOut tout;
				
		tout = getThread(UID);
		
		if (tout != null) {
		
			tout.putMessage(m);
		
		}		    
  }
  
  public synchronized void putMessage(Message m) {

    //    System.out.println("ComThread: Message received by commutation thread");

    q.putMessage(m);
  
  }

 
  public Vector getAllThreads() {

    return out;
  }
  
 
  public ComSessionTable getSessionTable() {

    return table;

  }
  
}

 






